<?php

// IPplan v4.31
// Sep 16, 2004 - modified by JMM
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//

require_once("../ipplanlib.php");
require_once("../adodb/adodb.inc.php");
require_once("../class.dbflib.php");
require_once("../layout/class.layout");
require_once("../auth.php");

$auth = new BasicAuthenticator(ADMINREALM, REALMERROR);

$auth->addUser(ADMINUSER, ADMINPASSWD);

// And now perform the authentication
$auth->authenticate();

// set language
isset($_COOKIE["ipplanNoAuth"]) && myLanguage($_COOKIE['ipplanLanguage']);

//setdefault("window",array("bgcolor"=>"white"));
//setdefault("table",array("cellpadding"=>"0"));
//setdefault("text",array("size"=>"2"));

$title=my_("IPPlan User Administration");
$title2=my_("Create New User");
newhtml($p);
$w=myheading($p, $title, "admin.php");

// explicitly cast variables as security measure against SQL injection
list($userid, $userdescrip, $password1, $password2, $grp, $search) = myRegister("S:userid S:userdescrip S:password1 S:password2 S:grp S:search");
$formerror="";

$ds=new IPplanDbf() or myError($w,$p, my_("Could not connect to database"));

if ($_POST) {
   $userid=trim($userid);
   $userdescrip=trim($userdescrip);
   $search=trim($search);
   if (AUTH_INTERNAL) {
      $password1=trim($password1);
      $password2=trim($password2);
   }
   else {
      // generate random password in case user changes authentication
      // from external to internal at some point
      $password1=$password2=rand(10000, 1000000);
   }

   if (strlen($userid) < 2) {
      $formerror .= my_("The user-id must be longer")."\n";
   }
   if (strlen($userdescrip) < 2) {
      $formerror .= my_("The user description must be longer")."\n";
   }
   if (strlen($password1) < 5 or strlen($password2) < 5) {
      $formerror .= my_("The password entered must be at least five characters")."\n";
   }
   if ($password1 != $password2) {
      $formerror .= my_("The passwords entered do not match")."\n";
   }

   if (!$formerror) {
       $password=crypt($password1, 'xq');

       $ds->DbfTransactionStart();
       // emulates mysql REPLACE
       $result=&$ds->ds->Execute("DELETE FROM users
               WHERE userid=".$ds->ds->qstr($userid));
       $result=&$ds->ds->Execute("INSERT INTO users
               (userid, userdescrip, password) 
               VALUES
               (".$ds->ds->qstr($userid).",
                ".$ds->ds->qstr($userdescrip).",
                ".$ds->ds->qstr($password).")");

       // add group if user selected a group other than "No group"
       if (!empty($grp)) {
           $result=&$ds->ds->Execute("DELETE FROM usergrp
                   WHERE userid=".$ds->ds->qstr($userid)." AND
                   grp=".$ds->ds->qstr($grp));
           $result=&$ds->ds->Execute("INSERT INTO usergrp
                   (userid, grp)
                   VALUES
                   (".$ds->ds->qstr($userid).",
                    ".$ds->ds->qstr($grp).")");
       }

       if ($result) {
           $ds->DbfTransactionEnd();

           if ($ds->ds->Affected_Rows() == 2)
               insert($w,text(my_("Existing user overwritten")));
           else
               insert($w,text(my_("User created")));
       }
       else {
           $formerror .= my_("User could not be created")."\n";
       }
   }
}

if ($search == "") {
    myError($w,$p, $formerror, FALSE);
} else {
    insert($w,text("Search complete"));
}

// display opening text
insert($w,heading(3, $title2));

// start form

insert($w, $f = form(array("method"=>"post",
                    "action"=>$_SERVER["PHP_SELF"])));

insert($f,block("<table><tr><td>"));
insert($f,textbrbr(my_("User-id (case sensitive!):")));
insert($f,input_text(array("name"=>"userid",
                    "value"=>"$userid",
                    "size"=>"20",
                    "maxlength"=>"40")));
insert($f,block("</td><td>"));
insert($f,textbrbr(my_("User's fullname:")));
insert($f,input_text(array("name"=>"userdescrip",
                    "value"=>"$userdescrip",
                    "size"=>"40",
                    "maxlength"=>"80")));
insert($f,block("</td><td>"));
if (AUTH_INTERNAL) {
    insert($f,textbrbr(my_("Password (case sensitive!):")));
    insert($f,password(array("name"=>"password1",
                    "value"=>"$password1",
                    "size"=>"20",
                    "maxlength"=>"40")));
    insert($f,block("</td><td>"));
    insert($f,textbrbr(my_("Password (again):")));
    insert($f,password(array("name"=>"password2",
                    "value"=>"$password2",
                    "size"=>"20",
                    "maxlength"=>"40")));
    insert($f,block("</td></tr>"));
}

insert($f,block("</td></tr></table>"));

$result2=$ds->GetGrps();

$lst=array(""=>"No group");
while($row = $result2->FetchRow()) {
    $col=$row["grp"];
    $lst["$col"]=$row["grpdescrip"];
}
insert($f,textbrbr(my_("Group")));
insert($f,selectbox($lst,
                array("name"=>"grp")));

insert($f,generic("br"));
insert($f,submit(array("value"=>my_("Create User"))));
insert($f,freset(array("value"=>my_("Clear"))));
insert($f,block("<hr>"));
insert($f,textb(my_("Current User Accounts")));

// start search form
             
insert($w, $f1 = form(array("method"=>"get",
                            "action"=>$_SERVER["PHP_SELF"])));
             
insert($f1,textbrbr(my_("Search userid or realname (case insensitive!):")));
insert($f1,input_text(array("name"=>"search",
                            "value"=>"$search",
                            "size"=>"20",
                            "maxlength"=>"40")));

insert($f1,generic("br"));
insert($f1,submit(array("value"=>my_("Search"))));

// gather data

if ($search != "") {
    $result=&$ds->ds->Execute("SELECT userid, userdescrip
            FROM users
            WHERE userid LIKE ".$ds->ds->qstr("%".$search."%")
            ." OR userdescrip LIKE ".$ds->ds->qstr("%".$search."%")."
            ORDER by userid");
} else {
    $result=&$ds->ds->Execute("SELECT userid, userdescrip
            FROM users
            ORDER by userid");
}

// create a table
insert($w,$t = table(array("cols"=>"3",
                           "class"=>"outputtable")));
// draw heading
setdefault("cell",array("class"=>"heading"));
insert($t,$c = cell());
insert($c,text(my_("Username")));
insert($t,$c = cell());
insert($c,text(my_("Real Name")));
insert($t,$c = cell());
insert($c,text(my_("Admin")));


$cnt=0;

while($row = $result->FetchRow()) {
setdefault("cell",array("class"=>color_flip_flop()));

    insert($t,$c = cell());
    insert($c,text($row["userid"]));

    insert($t,$c = cell());
    insert($c,text($row["userdescrip"]));

    insert($t,$c = cell());
    if ($row["userid"] != "") {
        insert($c,block("<small>"));
        insert($c,anchor("deleteaccess.php?user=".urlencode($row["userid"]), 
                    my_("Delete user"),
                    $ipplanParanoid ? array("onclick"=>"return confirm('".my_("Are you sure?")."')") : FALSE));
        if (AUTH_INTERNAL) {
            insert($c,block(" | "));
            insert($c,anchor("changepassword.php?user=".urlencode($row["userid"]), 
                        my_("Change user password")));
        }
        insert($c,block("</small>"));
    }

    $cnt++;

}

insert($w,block("<p><b>".sprintf(my_("Total records: %u"), $cnt)."</b>"));

$result->Close();
printhtml($p);

?>
