<?php

// IPplan v4.31
// Aug 24, 2001
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//

require_once("../ipplanlib.php");
require_once("../adodb/adodb.inc.php");
require_once("../class.dbflib.php");
require_once("../layout/class.layout");
require_once("../auth.php");

$auth = new BasicAuthenticator(ADMINREALM, REALMERROR);

$auth->addUser(ADMINUSER, ADMINPASSWD);

// And now perform the authentication
$auth->authenticate();

// set language
isset($_COOKIE["ipplanNoAuth"]) && myLanguage($_COOKIE['ipplanLanguage']);

//setdefault("window",array("bgcolor"=>"white"));

$title=my_("Delete access control results");
newhtml($p);
$w=myheading($p, $title, "admin.php");

// explicitly cast variables as security measure against SQL injection
list($user, $usergrp, $grp) = myRegister("S:user S:usergrp S:grp");

// basic sequence is connect, search, interpret search
// result, close connection

$ds=new IPplanDbf() or myError($w,$p, my_("Could not connect to database"));

// NOTE: don't change order of if's!!!

// delete a user
if ($user) {
   $ds->DbfTransactionStart();
   $result=&$ds->ds->Execute("DELETE FROM users
                           WHERE userid=".$ds->ds->qstr($user)) and
   $result=&$ds->ds->Execute("DELETE FROM usergrp
                           WHERE userid=".$ds->ds->qstr($user));

   if ($result) {
      $ds->DbfTransactionEnd();
      insert($w,text(my_("User deleted")));
   }
   else {
      insert($w,text(my_("User could not be deleted")));
   }
}
// delete user from group
else if ($usergrp) {

   $user=$usergrp;

   $ds->DbfTransactionStart();
   $result=&$ds->ds->Execute("DELETE FROM usergrp
                           WHERE userid=".$ds->ds->qstr($user)." AND
                              grp=".$ds->ds->qstr($grp));

   if ($result) {
      $ds->DbfTransactionEnd();
      insert($w,text(my_("User deleted from group")));
   }
   else {
      insert($w,text(my_("User could not be deleted from group")));
   }

}
else if ($grp) {

   // check if grp has customers
   $result=&$ds->ds->Execute("SELECT custdescrip
                           FROM customer
                           WHERE admingrp=".$ds->ds->qstr($grp));
   if ($row=$result->FetchRow()) {
      insert($w,text(my_("Cannot delete group because the following customers are assigned to the group:")));
      insert($w,block("<p>"));
      do {
          insert($w,text($row["custdescrip"]));
          insert($w,textbr());
      } while($row=$result->FetchRow());

      printhtml($p);
      exit;
   } 

   // check if grp has subnets
   $result=&$ds->ds->Execute("SELECT baseaddr, descrip
                           FROM base
                           WHERE admingrp=".$ds->ds->qstr($grp)."
                           ORDER BY baseaddr");
   if ($row=$result->FetchRow()) {
      insert($w,text(my_("Cannot delete group because the following subnets are assigned to the group:")));
      insert($w,block("<p>"));

      do {
          insert($w,text(inet_ntoa($row["baseaddr"])." - ".$row["descrip"]));
          insert($w,textbr());
      } while($row = $result->FetchRow());

      printhtml($p);
      exit;
   } 

   $ds->DbfTransactionStart();
   $result=&$ds->ds->Execute("DELETE FROM grp
                           WHERE grp=".$ds->ds->qstr($grp)) and
   $result=&$ds->ds->Execute("DELETE FROM usergrp
                           WHERE grp=".$ds->ds->qstr($grp)) and
   $result=&$ds->ds->Execute("DELETE FROM bounds
                           WHERE grp=".$ds->ds->qstr($grp));

   if ($result) {
      $ds->DbfTransactionEnd();
      insert($w,text(my_("Group deleted")));
   }
   else {
      insert($w,text(my_("Group could not be deleted")));
   }
}

printhtml($p);

?>
