<?php

// IPplan v4.31
// Aug 24, 2001
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//

require_once("../ipplanlib.php");
require_once("../adodb/adodb.inc.php");
require_once("../class.dbflib.php");
require_once("../layout/class.layout");
require_once("../auth.php");

$auth = new BasicAuthenticator(ADMINREALM, REALMERROR);

$auth->addUser(ADMINUSER, ADMINPASSWD);

// And now perform the authentication
$auth->authenticate();

// set language
isset($_COOKIE["ipplanNoAuth"]) && myLanguage($_COOKIE['ipplanLanguage']);

//setdefault("window",array("bgcolor"=>"white"));
//setdefault("table",array("cellpadding"=>"0"));
//setdefault("text",array("size"=>"2"));

$title=my_("Display user access information");
newhtml($p);
$w=myheading($p, $title, "admin.php");

// explicitly cast variables as security measure against SQL injection
list($grp) = myRegister("S:grp");

// basic sequence is connect, search, interpret search
// result, close connection
$ds=new IPplanDbf() or myError($w,$p, my_("Could not connect to database"));

// group search from another form
if (!$grp) {
   $result=&$ds->ds->Execute("SELECT grp.grpdescrip, grp.grp, usergrp.userid,
                           grp.createcust, grp.grpopt, users.userdescrip
                        FROM grp
                        LEFT JOIN usergrp
                        ON grp.grp=usergrp.grp
                        LEFT JOIN users
                        ON usergrp.userid=users.userid
                        ORDER BY grp.grp");

   insert($w,heading(3, my_("All groups and users assigned to them")));
}
else {
   $result=&$ds->ds->Execute("SELECT grp.grpdescrip, grp.grp, grp.createcust,
                           grp.grpopt, usergrp.userid, users.userdescrip
                        FROM grp
                        LEFT JOIN usergrp
                        ON grp.grp=usergrp.grp
                        LEFT JOIN users
                        ON usergrp.userid=users.userid
                        WHERE grp.grp=".$ds->ds->qstr($grp)."
                        ORDER BY grp.grp");

   insert($w,heading(3, sprintf(my_("All info for group %s"), $grp)));
}

// create a table
insert($w,$t = table(array("cols"=>"6",
                           "class"=>"outputtable")));
// draw heading
setdefault("cell",array("class"=>"heading"));
insert($t,$c = cell());
insert($c,text(my_("Group description")));
insert($t,$c = cell());
insert($c,text(my_("Group name")));
insert($t,$c = cell());
insert($c,text(my_("Group action")));
insert($t,$c = cell());
insert($c,text(my_("User's fullname")));
insert($t,$c = cell());
insert($c,text(my_("User-id")));
insert($t,$c = cell());
insert($c,text(my_("User action")));

$cnt=0;
$savegrp="";
while($row = $result->FetchRow()) {
setdefault("cell",array("class"=>color_flip_flop()));

    if ($savegrp==$row["grp"]) {
        insert($t,$c = cell(array("colspan"=>"3")));
        //        insert($t,$c = cell());
        //        insert($t,$c = cell());
    }
    else {
        insert($t,$c = cell());
        insert($c,text($row["grpdescrip"]));

        insert($t,$c = cell());
        insert($c,text($row["grp"]));

        insert($t,$c = cell());
        insert($c,block("<small>"));
        insert($c,anchor("displayboundsform.php?grp=".urlencode($row["grp"]), 
                    my_("Display/delete group bounds")));
        insert($c,block(" | "));
        insert($c,anchor("deleteaccess.php?grp=".urlencode($row["grp"]), 
                    my_("Delete group"),
                    $ipplanParanoid ? array("onclick"=>"return confirm('".my_("Are you sure?")."')") : FALSE));
        insert($c,block(" | "));
        insert($c,anchor("modifygroup.php?grp=".urlencode($row["grp"]).
                    "&grpdescrip=".urlencode($row["grpdescrip"]).
                    "&createcust=".$row["createcust"].
                    "&grpopt=".$row["grpopt"], 
                    my_("Modify group details")));
        insert($c,block("</small>"));
    }

    if (empty($row["userid"])) {
        insert($t,$c = cell(array("colspan"=>"3")));
        insert($c,block("<i>"));
        insert($c,text(my_("No users belong to this group")));
        insert($c,block("</i>"));
    }
    else {
        insert($t,$c = cell());
        insert($c,text($row["userdescrip"]));

        insert($t,$c = cell());
        insert($c,text($row["userid"]));

        insert($t,$c = cell());
        insert($c,block("<small>"));
        insert($c,anchor("deleteaccess.php?usergrp=".urlencode($row["userid"]).
                    "&grp=".urlencode($row["grp"]), 
                    my_("Delete user from group"),
                    $ipplanParanoid ? array("onclick"=>"return confirm('".my_("Are you sure?")."')") : FALSE));
        insert($c,block(" | "));
        insert($c,anchor("deleteaccess.php?user=".urlencode($row["userid"]), 
                    my_("Delete user"),
                    $ipplanParanoid ? array("onclick"=>"return confirm('".my_("Are you sure?")."')") : FALSE));
        if (AUTH_INTERNAL) {
            insert($c,block(" | "));
            insert($c,anchor("changepassword.php?user=".urlencode($row["userid"]), 
                        my_("Change user password")));
        }
        insert($c,block("</small>"));
    }

    $cnt++;
    $savegrp=$row["grp"];

}

insert($w,block("<p><b>".sprintf(my_("Total records: %u"), $cnt)."</b>"));

$result=&$ds->ds->Execute("SELECT users.userdescrip, users.userid 
                        FROM users
                        LEFT JOIN usergrp
                        ON users.userid = usergrp.userid
                        WHERE usergrp.userid IS NULL
                        ORDER BY users.userid");

insert($w,heading(3, my_("Users not assigned to any group")));
insert($w,text(my_("These users will not be able to login as they do not have access anywhere.")));
insert($w,block("<p>"));

setdefault("cell", FALSE);
// create a table
insert($w,$t = table(array("cols"=>"3",
                           "class"=>"outputtable")));
// draw heading
setdefault("cell",array("class"=>"heading"));
insert($t,$c = cell());
insert($c,text(my_("User's fullname")));
insert($t,$c = cell());
insert($c,text(my_("User-id")));
insert($t,$c = cell());
insert($c,text(my_("User action")));

$cnt=0;
while($row = $result->FetchRow()) {
setdefault("cell",array("class"=>color_flip_flop()));

    insert($t,$c = cell());
    insert($c,text($row["userdescrip"]));

    insert($t,$c = cell());
    insert($c,text($row["userid"]));

    insert($t,$c = cell());
    insert($c,block("<small>"));
    insert($c,anchor("deleteaccess.php?user=".urlencode($row["userid"]), 
                     my_("Delete user"),
                     $ipplanParanoid ? array("onclick"=>"return confirm('".my_("Are you sure?")."')") : FALSE));
    if (AUTH_INTERNAL) {
       insert($c,block(" | "));
       insert($c,anchor("changepassword.php?user=".urlencode($row["userid"]), 
                        my_("Change user password")));
    }
    insert($c,block("</small>"));

    $cnt++;

}

insert($w,block("<p><b>".sprintf(my_("Total records: %u"), $cnt)."</b>"));

$result->Close();
printhtml($p);

?>
