<?php

// IPplan v4.31
// Aug 24, 2001
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//

require_once("../ipplanlib.php");
require_once("../adodb/adodb.inc.php");
require_once("../class.dbflib.php");
require_once("../layout/class.layout");
require_once("../auth.php");

if (!ANONYMOUS) {
   $auth = new SQLAuthenticator(REALM, REALMERROR);

   // And now perform the authentication
   $auth->authenticate();
}

// save the last customer used
// must set path else Netscape gets confused!
setcookie("ipplanCustomer","$cust",time() + 10000000, "/");

// set language
isset($_COOKIE["ipplanNoAuth"]) && myLanguage($_COOKIE['ipplanLanguage']);

//setdefault("window",array("bgcolor"=>"white"));
//setdefault("table",array("cellpadding"=>"0"));
//setdefault("text",array("size"=>"2"));

$title=my_("Results of your search");
newhtml($p);
$w=myheading($p, $title, "../index.php", true);

// explicitly cast variables as security measure against SQL injection
list($cust, $areaindex, $rangeindex, $start, $end, $showused) = myRegister("I:cust I:areaindex I:rangeindex S:start S:end I:showused");

if (!$_GET) {
   myError($w,$p, my_("You cannot reload or bookmark this page!"));
}

// basic sequence is connect, search, interpret search
// result, close connection
$ds=new IPplanDbf() or myError($w,$p, my_("Could not connect to database"));

// set start and end address according to range
$site="";
if ($rangeindex) {
   // should only return one row here!
   $result=$ds->GetRange($cust, $rangeindex);
   $row = $result->FetchRow();
 
   $start=inet_ntoa($row["rangeaddr"]);
   $end=inet_ntoa($row["rangeaddr"]+$row["rangesize"]-1);
   $site=" (".$row["descrip"].")";
}

if (testIP($start) or testIP($end)) {
   myError($w,$p, my_("Invalid IP address! You must select a range or fill in the start and end IP address."));
}

$startnum=inet_aton($start);
$endnum=inet_aton($end);

if ($endnum <= $startnum) {
   myError($w,$p, my_("Your end ip address is smaller than your start!"));
}

$custdescrip=$ds->GetCustomerDescrip($cust);

insert($w,heading(3, sprintf(my_("Search for IP subnets between %s and %s %s for customer '%s'"), $start, $end, $site, $custdescrip)));

$result=&$ds->ds->Execute("SELECT base.baseindex, base.subnetsize, base.descrip, 
                          base.baseaddr,
                          base.admingrp, count(ipaddr.baseindex) AS cnt
                        FROM base
                        LEFT JOIN ipaddr 
                          ON base.baseindex=ipaddr.baseindex
                        WHERE base.baseaddr BETWEEN $startnum AND $endnum 
                          AND base.customer=$cust 
                        GROUP BY base.baseindex, base.subnetsize, base.descrip,
                          base.baseaddr, base.admingrp
                        ORDER BY
                           base.baseaddr");

// create a table
insert($w,$t = table(array("cols"=>"5",
                           "class"=>"outputtable")));
// draw heading
setdefault("cell",array("class"=>"heading"));
insert($t,$c = cell());
insert($c,text(my_("Base address")));
insert($t,$c = cell());
insert($c,text(my_("Subnet size")));
insert($t,$c = cell());
insert($c,text(my_("Subnet mask")));
insert($t,$c = cell());
insert($c,text(my_("Description")));
insert($t,$c = cell());
insert($c,text(my_("Utilization")));


// read entire result set into memory
$maxcnt=0;
while($row = $result->FetchRow()) {
    $arr[$maxcnt++]=$row;
}
    
$cnt=0;
$cntfree=0;
$cntsubsize=0;
$cntfreesubsize=0;
$used=0;
for ($i=0; $i < $maxcnt; $i++) {
    setdefault("cell",array("class"=>color_flip_flop()));

    if (substr(strtolower($arr[$i]["descrip"]),0,4)=="free" or
            substr(strtolower($arr[$i]["descrip"]),0,5)=="spare") {
        $free=1;
        $cntfree++;
    }
    else {
        $free=0;
        // don't display anything if only unassigned is selected
        if ($showused == 2) {
            $cnt++;
            continue;
        }
    }

    // handle beginning of range
    if ($rangeindex) {
        if ($i==0 and $startnum!=$arr[$i]["baseaddr"]) {
            insert($t,$c = cell(array("class"=>"greencell")));
            insert($c,anchor("createsubnetform.php?ipaddr=".$start."&cust=".$cust, 
                        $start));
            insert($t,$c = cell());
            insert($c,text($arr[$i]["baseaddr"]-$startnum));
            insert($t,$c = cell());
            insert($t,$c = cell());
            insert($c,text(my_("Free space")));
            insert($t,$c = cell());
        }
    }

    // only show used space if user asked for it
    if ($showused == 1 or $free) {

        // exclude free networks from allocated space calculations
        if ($free) {
            $cntfreesubsize += $arr[$i]["subnetsize"];
            insert($t,$c = cell(array("class"=>"greencell")));
            insert($c,anchor("modifybase.php?cust=".$cust."&ipaddr=".
                        inet_ntoa($arr[$i]["baseaddr"]),
                        inet_ntoa($arr[$i]["baseaddr"])));
        }
        else {
            $cntsubsize += $arr[$i]["subnetsize"];
            insert($t,$c = cell());
            insert($c,anchor("displaysubnet.php?baseindex=".$arr[$i]["baseindex"], 
                        inet_ntoa($arr[$i]["baseaddr"])));
        }

        if ($arr[$i]["subnetsize"] == 1) {
            insert($t,$c = cell());
            insert($c,text(my_("Host")));
        }
        else {
            insert($t,$c = cell());
            insert($c,text($arr[$i]["subnetsize"]));
        }

        insert($t,$c = cell());
        insert($c,text(inet_ntoa(inet_aton(ALLNETS)+1 -
                        $arr[$i]["subnetsize"])."/".inet_bits($arr[$i]["subnetsize"])));

        insert($t,$c = cell());
        // hack to make it more intuitive for ISP's
        if ($free) {
            insert($c,text(my_("Free/Unassigned space")));
        }
        else {
            insert($c,text($arr[$i]["descrip"]));
        }
        // display utilization
        insert($t,$c = cell());
        if ($arr[$i]["subnetsize"] == 1) {
            insert($c,text("1/100%"));
            $used++;
        }
        else {
            insert($c,text(($arr[$i]["cnt"]+2)."/".
                        round(($arr[$i]["cnt"]+2)/$arr[$i]["subnetsize"]*100,2)."%"));
            // add reserved addresses
            $used+=$arr[$i]["cnt"]+2;
        }
    }

    if ($i != $maxcnt-1 and 
        $arr[$i]["baseaddr"]+$arr[$i]["subnetsize"] != $arr[$i+1]["baseaddr"] and
        $showused != 2) {
        $newbase=inet_ntoa($arr[$i]["baseaddr"]+$arr[$i]["subnetsize"]);
        $newsize=$arr[$i+1]["baseaddr"]-$arr[$i]["baseaddr"]-$arr[$i]["subnetsize"];

        insert($t,$c = cell(array("class"=>"greencell")));
        insert($c,anchor("createsubnetform.php?ipaddr=".$newbase.
                    "&cust=".$cust."&size=".$newsize, 
                    $newbase));
        insert($t,$c = cell());
        insert($c,text($newsize));
        insert($t,$c = cell());
        insert($t,$c = cell());
        insert($c,text(my_("Free space")));
        insert($t,$c = cell());
    }

    $cnt++;

}

// handle end of range
if ($cnt and $showused != 2) {
   if ($endnum!=$arr[$i-1]["baseaddr"]+$arr[$i-1]["subnetsize"]-1) {
    insert($t,$c = cell(array("class"=>"greencell")));
    insert($c,anchor("createsubnetform.php?ipaddr=".
           inet_ntoa($arr[$i-1]["baseaddr"]+$arr[$i-1]["subnetsize"]).
           "&cust=".$cust, 
           inet_ntoa($arr[$i-1]["baseaddr"]+$arr[$i-1]["subnetsize"])));
    insert($t,$c = cell());
    insert($c,text($endnum+1-$arr[$i-1]["baseaddr"]-
                    $arr[$i-1]["subnetsize"]));
    insert($t,$c = cell());
    insert($t,$c = cell());
    insert($c,text(my_("Free space")));
    insert($t,$c = cell());
   }
}

// display totals
if ($showused == 1 ) {
   insert($t,$c = cell());
   insert($c,textb(my_("Total:")));
   insert($t,$c = cell());
   insert($c,textb($endnum-$startnum+1));
   insert($t,$c = cell());
   insert($t,$c = cell());
   insert($t,$c = cell());
   insert($c,textb($used));

   insert($w,block("<p>"));
   insert($w,textb(my_("Total allocated networks/subnets: ")));
   insert($w,textbr($cnt));
   insert($w,textb(my_("Network/subnet space allocated: ")));
   insert($w,textbr(round($cntsubsize/($endnum-$startnum+1)*100, 2)."%"));
   insert($w,textb(my_("Total unassigned subnets (pre-allocated subnets marked as free): ")));
   insert($w,textbr($cntfree));
   insert($w,textb(my_("Unassigned subnets (pre-allocated subnets marked as free): ")));
   insert($w,textbr(round($cntfreesubsize/($endnum-$startnum+1)*100, 2)."%"));
   insert($w,textb(my_("IP addresses allocated: ")));
   insert($w,text(round($used/($endnum-$startnum+1)*100, 2)."%"));
}

$result->Close();
printhtml($p);

?>
